SaveVidLevel = VideoLevel
EchoOff

; B24ClusterOs>Install.jcl
; Install the B24 RealMode Cluster Operating System subpackage

; Except for yesno strings, these two messages are the only nationalizable
; strings in this file.
ErrorMsg     = 'Cannot access B24ClusterOs>InstallMsg.bin'
FirstDisk    = 'Real Mode OS Diskette 1 of 4 (B25R341)'

FromFloppy   = 0
FromServer   = 2
TotalNoise   = 0
TotalSilence = 2
NotFound     = 65535
ClearScreen  = 'PF'

If SaveVidLevel = TotalNoise
   Display(ClearScreen)
EndIf

OsName       = 'v1Clstr.run'
FontName     = 'v1Sys.font'
FloppySpec   = ConcatStrings(DeviceFrom, '<CTOS>')
OsFrom       = ConcatStrings(FloppySpec, OsName)
FontFrom     = ConcatStrings(FloppySpec, FontName)
ToSpec       = ConcatStrings(VolumeTo, DirectoryTo)
PublicOsTo   = ConcatStrings(ToSpec, OsName)
PublicFontTo = ConcatStrings(ToSpec, FontName)
PublicWsTo   = ConcatStrings(ToSpec, 'Ws200>SysImage.sys')
EtcFromSpec  = ConcatStrings(DeviceFrom, '<OsInstall>')
ConfigFile   = 'Config.sys'
NlsKbdFile   = 'NlsKbd.sys'

If InstallType = FromFloppy
   NextFloppy(FirstDisk)
EndIf

InitErc = InitMsgFile(MsgFile)
If InitErc <> 0
   DisplayLine(ErrorMsg)
   Cancel
EndIf

If InstallType = FromServer
   Msg = GetMsg(5)
   DisplayLine(Msg)
   DisplayLine
   Msg = GetMsg(7)
   DisplayAndWait(Msg)
   Cancel
EndIf

If Not Public
   Msg = GetMsg(6)
   DisplayLine(Msg)
   DisplayLine
   Msg = GetMsg(7)
   DisplayAndWait(Msg)
   Cancel
EndIf

If SaveVidLevel = TotalNoise
   EchoSome
EndIf
DisplayLine
Command LCopy          ,
           ConfigFile  ,
           EtcFromSpec ,
           ToSpec      ,
                       ,
           No          ,
           No          ,
           No          ,
           Yes
Msg = GetMsg(17)
ConfigSpec = ConcatStrings(ToSpec, Msg)
DisplayLine
Command LCopy          ,
           ConfigFile  ,
           EtcFromSpec ,
           ConfigSpec  ,
                       ,
           No          ,
           No          ,
           No          ,
           Yes
FileName = ConcatStrings(ToSpec, NlsKbdFile)
Ver = FileVersion(FileName)
If Ver <> '0'
   Msg = GetMsg(16)
   SaveSpec = ConcatStrings(ToSpec, Msg)
   FileName = ConcatStrings(SaveSpec, NlsKbdFile)
   Ver = FileVersion(FileName)
   If Ver = '0'
      DisplayLine
      Command LCopy         ,
                 NlsKbdFile ,
                 ToSpec     ,
                 SaveSpec   ,
                            ,
                 No         ,
                 No         ,
                 No         ,
                 Yes
      DisplayLine
      Msg = ConcatStrings(ToSpec, NlsKbdFile)
      Display(Msg)
      Msg = GetMsg(15)
      Display(Msg)
      Display(ToSpec)
      Msg = GetMsg(16)
      Display(Msg)
      DisplayLine(NlsKbdFile)
   EndIf
EndIf
DisplayLine
Command LCopy          ,
           NlsKbdFile  ,
           EtcFromSpec ,
           ToSpec      ,
                       ,
           Yes         ,
           No          ,
           No          ,
            Yes
DisplayLine
Command LCopy                      ,
                                   ,
           OsFrom                  ,
           (PublicOsTo,PublicWsTo) ,
                                   ,
           Yes                     ,
           No                      ,
           No                      ,
           Yes

Command LCopy                      ,
                                   ,
           FontFrom                ,
           PublicFontTo            ,
                                   ,
           Yes                     ,
           No                      ,
           No                      ,
           Yes

If SaveVidLevel = TotalNoise
   EchoOff
EndIf

ChkPkgs:
DisplayLine

;B26 Cluster OS
Pkg = GetMsg(9)
If SubString(Pkg, Pkgs) <> NotFound
   Diskette = GetMsg(1)
   NextFloppy(Diskette)
   GoTo EndIt
EndIf

;B26 Cluster Lfs Os
Pkg = GetMsg(10)
If SubString(Pkg, Pkgs) <> NotFound
   Diskette = GetMsg(2)
   NextFloppy(Diskette)
   GoTo EndIt
EndIf

;B27 Cluster OS
Pkg = GetMsg(12)
If SubString(Pkg, Pkgs) <> NotFound
   Diskette = GetMsg(3)
   NextFloppy(Diskette)
   GoTo EndIt
EndIf

;B27 Cluster Lfs OS
Pkg = GetMsg(13)
If SubString(Pkg, Pkgs) <> NotFound
   Diskette = GetMsg(3)
   NextFloppy(Diskette)
   GoTo EndIt
EndIf

;B24 debugger
Pkg = GetMsg(8)	
If SubString(Pkg, Pkgs) <> NotFound
   Diskette = GetMsg(4)
   NextFloppy(Diskette)
   GoTo EndIt
EndIf

;B26 Debugger
Pkg = GetMsg(11)
If SubString(Pkg, Pkgs) <> NotFound
   Diskette = GetMsg(4)
   NextFloppy(Diskette)
   GoTo EndIt
EndIf

;B27 Debugger
Pkg = GetMsg(14)
If SubString(Pkg, Pkgs) <> NotFound
   Diskette = GetMsg(4)
   NextFloppy(Diskette)
   GoTo EndIt
EndIf

EndIt:

End
