SaveVidLevel = VideoLevel
EchoOff

; pClusterLfsOs>Install.jcl
; Install the ProtectedMode Cluster LFS Operating System subpackage

; Except for yesno strings, these two messages are the only nationalizable
; strings in this file.
ErrorMsg     = 'Cannot access pClusterLfsOs>InstallMsg.bin'
FirstDisk    = 'Protected Mode OS Diskette 2 of 6 (B25POS2)'

FromFloppy   = 0
FromServer   = 2
TotalNoise   = 0
TotalSilence = 2
NotFound     = 65535
ClearScreen  = 'PF'

If SaveVidLevel = TotalNoise
   Display(ClearScreen)
EndIf

OsName       = 'pClstrLfs.img'
ServerSpec   = ConcatStrings(DeviceFrom, DirectoryTo)
OsFromServer = ConcatStrings(ServerSpec, OsName)
FloppySpec   = ConcatStrings(DeviceFrom, '<CTOS>')
OsFrom       = ConcatStrings(FloppySpec, OsName)
ToSpec       = ConcatStrings(VolumeTo, DirectoryTo)
PublicOsTo   = ConcatStrings(ToSpec, OsName)
WsSpec       = ConcatStrings(DeviceFrom, '<ClstrLfs>*')
PrivateOsTo  = ConcatStrings(ToSpec, 'SysImage.sys')
EtcFromSpec  = ConcatStrings(DeviceFrom, '<OsInstall>')
ConfigFile   = 'Config.sys'
NlsKbdFile   = 'NlsKbd.sys'

If InstallType = FromFloppy
   NextFloppy(FirstDisk)
EndIf

InitErc = InitMsgFile(MsgFile)
If InitErc <> 0
   DisplayLine(ErrorMsg)
   Cancel
Endif

If InstallType = FromServer
   If SaveVidLevel = TotalNoise
      EchoSome
   EndIf
   DisplayLine
   Command LCopy           ,
                           ,
              OsFromServer ,
              PrivateOsTo  ,
                           ,
              Yes          ,
              No           ,
              No           ,
              Yes
   DisplayLine
   Command LCopy         ,
              ConfigFile ,
              ServerSpec ,
              ToSpec     ,
                         ,
              No         ,
              No         ,
              No         ,
              Yes
   Msg = GetMsg(7)
   ConfigSpec = ConcatStrings(ToSpec, Msg)
   DisplayLine
   Command LCopy         ,
              ConfigFile ,
              ServerSpec ,
              ConfigSpec ,
                         ,
              Yes        ,
              No         ,
              No         ,
              Yes
   FileName = ConcatStrings(ToSpec, NlsKbdFile)
   Ver = FileVersion(FileName)
   If Ver <> '0'
      Msg = GetMsg(6)
      SaveSpec = ConcatStrings(ToSpec, Msg)
      FileName = ConcatStrings(SaveSpec, NlsKbdFile)
      Ver = FileVersion(FileName)
      If Ver = '0'
         DisplayLine
         Command LCopy         ,
                    NlsKbdFile ,
                    ToSpec     ,
                    SaveSpec   ,
                               ,
                    No         ,
                    No         ,
                    No         ,
                    Yes
         DisplayLine
         Msg = ConcatStrings(ToSpec, NlsKbdFile)
         Display(Msg)
         Msg = GetMsg(5)
         Display(Msg)
         Display(ToSpec)
         Msg = GetMsg(6)
         Display(Msg)
         DisplayLine(NlsKbdFile)
      EndIf
   EndIf
   DisplayLine
   Command LCopy         ,
              NlsKbdFile ,
              ServerSpec ,
              ToSpec     ,
                         ,
              Yes        ,
              No         ,
              No         ,
              Yes
   If SaveVidLevel = TotalNoise
      EchoOff
   EndIf
   GoTo ChkPkgs
Endif

If SaveVidLevel = TotalNoise
   EchoSome
EndIf
DisplayLine
Command LCopy          ,
           ConfigFile  ,
           EtcFromSpec ,
           ToSpec      ,
                       ,
           No          ,
           No          ,
           No          ,
           Yes
Msg = GetMsg(7)
ConfigSpec = ConcatStrings(ToSpec, Msg)
DisplayLine
Command LCopy          ,
           ConfigFile  ,
           EtcFromSpec ,
           ConfigSpec  ,
                       ,
           Yes         ,
           No          ,
           No          ,
           Yes
FileName = ConcatStrings(ToSpec, NlsKbdFile)
Ver = FileVersion(FileName)
If Ver <> '0'
   Msg = GetMsg(6)
   SaveSpec = ConcatStrings(ToSpec, Msg)
   FileName = ConcatStrings(SaveSpec, NlsKbdFile)
   Ver = FileVersion(FileName)
   If Ver = '0'
      DisplayLine
      Command LCopy         ,
                 NlsKbdFile ,
                 ToSpec     ,
                 SaveSpec   ,
                            ,
                 No         ,
                 No         ,
                 No         ,
                 Yes
      DisplayLine
      Msg = ConcatStrings(ToSpec, NlsKbdFile)
      Display(Msg)
      Msg = GetMsg(5)
      Display(Msg)
      Display(ToSpec)
      Msg = GetMsg(6)
      Display(Msg)
      DisplayLine(NlsKbdFile)
   EndIf
EndIf
DisplayLine
Command LCopy          ,
           NlsKbdFile  ,
           EtcFromSpec ,
           ToSpec      ,
                       ,
           Yes         ,
           No          ,
           No          ,
           Yes
If SaveVidLevel = TotalNoise
   EchoOff
EndIf

If Public
   OsTo = PublicOsTo
Else
   OsTo = PrivateOsTo
Endif

If SaveVidLevel = TotalNoise
   EchoSome
EndIf
DisplayLine
Command LCopy     ,
                  ,
           OsFrom ,
           OsTo   ,
                  ,
           Yes    ,
           No     ,
           No     ,
           Yes
If SaveVidLevel = TotalNoise
   EchoOff
EndIf

If Public
   If SaveVidLevel = TotalNoise
      EchoSome
   EndIf
   DisplayLine
   Command LCopy     ,
              WsSpec ,
                     ,
              ToSpec ,
                     ,
              Yes    ,
              No     ,
              No     ,
              Yes
   If SaveVidLevel = TotalNoise
      EchoOff
   EndIf
EndIf

ChkPkgs:
DisplayLine

Pkg = GetMsg(2)
If SubString(Pkg, Pkgs) <> NotFound
   Diskette = GetMsg(1)
   NextFloppy(Diskette)
   GoTo EndIt
EndIf

Pkg = GetMsg(3)
If SubString(Pkg, Pkgs) <> NotFound
   Diskette = GetMsg(4)
   NextFloppy(Diskette)
   GoTo EndIt
EndIf

EndIt:

End
ConcatStrings(ToSpec, OsName)
WsSpec       = ConcatStrings(DeviceFrom, '<ClstrLfs>*')
PrivateOsTo  = ConcatStrings(ToSpec, 'SysImage.sys')
EtcFromSpec  = ConcatStrings(DeviceFrom, '<OsInstall>')
